"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path = require("path");

var _serveStatic = _interopRequireDefault(require("serve-static"));

var _buildDll = _interopRequireDefault(require("./buildDll"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _default(api, opts = {}) {
  if (process.env.NODE_ENV !== 'development') return;
  const _api$utils = api.utils,
        webpack = _api$utils._webpack,
        afWebpackGetConfig = _api$utils._afWebpackGetConfig,
        afWebpackBuild = _api$utils._afWebpackBuild,
        webpackHotDevClientPath = _api$utils._webpackHotDevClientPath;
  const paths = api.service.paths;
  const dllDir = (0, _path.join)(paths.absNodeModulesPath, 'umi-dlls');
  const dllManifest = (0, _path.join)(dllDir, 'umi.json');
  api.register('beforeDevAsync', () => {
    return new Promise(resolve => {
      process.env.HARD_SOURCE = 'none';
      (0, _buildDll.default)(_objectSpread({
        webpack,
        afWebpackGetConfig,
        afWebpackBuild,
        webpackHotDevClientPath,
        service: api.service,
        dllDir
      }, opts)).then(() => {
        process.env.HARD_SOURCE = '';
        resolve();
      }).catch(e => {
        console.log('[umi-plugin-dll] error', e);
      });
    });
  });
  api.register('modifyMiddlewares', ({
    memo
  }) => {
    return [(0, _serveStatic.default)(dllDir), ...memo];
  });
  api.register('modifyWebpackConfig', ({
    memo
  }) => {
    memo.plugins.push(new webpack.DllReferencePlugin({
      context: paths.absSrcPath,
      manifest: dllManifest
    }));
    return memo;
  });
  api.register('modifyHTML', ({
    memo
  }) => {
    memo = memo.replace('</head>', `
<script src="/umi.dll.js"></script>
</head>
    `.trim());
    return memo;
  });
}